#include <HardwareSerial.h>
#include "Utils.h"

bool appendUntil(Stream& source, char* buffer, int bufSize, char terminator)
{
    int data=source.read();
    if (data>=0)
    {
        int len=strlen(buffer);
        do
        {
            if (len<bufSize-1)
            {
                buffer[len++]=data;
            }
            if (data==terminator)
            {
                buffer[len]=0;
                return true;
            }
            data=source.read();
        }
        while (data>=0);
        buffer[len]=0;  
    }
    return false;
}


bool flushUntil(Stream& source, char terminator)
{
    int data=source.read();
    while (data>=0)
    {
        if (data==terminator)
        {
            return true;
        }
        data=source.read();
    }
    return false;
}


void urlDecode(char* buffer, int bufSize, const char* source)
{
    int bufferIndex=0;
    int sourceIndex=0;
    while (bufferIndex<bufSize-1)
    {
        if (source[sourceIndex]==0)
        {
            // end of string reached
            break;
        }
        else if (source[sourceIndex]=='&')
        {
            // next parameter reached
            break;
        }
        else if (source[sourceIndex]==' ')
        {
            // end of URL parameters reached
            break;
        }
        else if (source[sourceIndex]=='+')
        {
            // replace '+' by ' '
            buffer[bufferIndex++]=' ';
            sourceIndex++;            
        }
        else if (source[sourceIndex]=='%')
        {
            long l=strtol(source+sourceIndex+1,NULL,16);
            buffer[bufferIndex++]=l & 0xFF;
            sourceIndex+=3; 
        }
        else
        {
            // any other character
            buffer[bufferIndex++]=source[sourceIndex++];
        }
    }
    buffer[bufferIndex]=0;
}
